/*************************************
**function : Port test(output)-using ODR Register
           : TIMER2 TEST ;TIMER OVERFLOW INTERRUPT
**date     : 2012/11/12
**programmed by ksc
***************************************/
/***************************************
**define reset and clock control RCC
**RCC_base_address 0x40021000
***************************************/
#define RCC_CR_address        0x40021000  //clock control register
#define RCC_CFGR_address      0x40021004  //clock configuration register
#define RCC_CIR_address       0x40021008  //clock interrupt register
#define RCC_APB2RSTR_address  0x4002100C  //APB2 peripheral reset register
#define RCC_APB1RSTR_address  0x40021010  //APB2 peripheral reset register 
#define RCC_AHBENR_address    0x40021014  // AHB peripheral clock enable register
#define RCC_APB2ENR_address   0x40021018  // APB2 peripheral clock enable register
#define RCC_APB1ENR_address   0x4002101C  // APB2 peripheral clock enable register
#define RCC_BDCR_address      0x40021020  // backup domain control register
#define RCC_CSR_address       0x40021020  // control/status register
/********************************************
//Flash Memory Control
*********************************************/
#define Flash_ACR_address 0x40022000

/******************************************
**define GPIOA register address
**portA_base_address  0x40010c00
*******************************************/
#define GPIOA_CRL_address    0x40010800
#define GPIOA_CRH_address    0x40010804
#define GPIOA_IDR_address    0x40010808
#define GPIOA_ODR_address    0x4001080c
#define GPIOA_BSRR_address   0x40010810
#define GPIOA_BRR_address    0x40010814
#define GPIOA_CLKR_address   0x40010818

/*******************************************
**define GPIOB register address
**portB_base_address  0x40010c00
*******************************************/
#define GPIOB_CRL_address    0x40010c00
#define GPIOB_CRH_address    0x40010c04
#define GPIOB_IDR_address    0x40010c08
#define GPIOB_ODR_address    0x40010c0c
#define GPIOB_BSRR_address   0x40010c10
#define GPIOB_BRR_address    0x40010c14
#define GPIOB_CLKR_address   0x40010c18
/**********************************************
**NVIC Register
**NVIC Base Address :0xE000E100
**ISER(interrupt set enable register)
**ICER(interrupt clear enable register)
**ISPR(interrupt set pending register)
***********************************************/
#define NVIC_ISER_address        0xE000E100
#define NVIC_ICER_address        0xE000E180
#define NVIC_ISPR_address        0xE000E200
#define NVIC_IPR_address         0xE000E404
/******************************************************
**System Control Block Register
**Base address : 0xE000D00
VTOR(Vector Table Offset register)     0xE000ED08
AIRCR(Application Interrupt/Reset Control register)    0xE000ED0C
*******************************************************/
#define SCB_VTOR_address      0xE000ED08
#define SCB_AIRCR_address     0xE000ED0C
/************************************************************
**AFIO                                Base address          :: 0x40010000
AFIO_EVCR(Event control register)                           :: 0ffset  :0x00
AFIO_MAPR(AF remap and debug I/O configuration register)    :: offset : 0x04
AFIO_EXTICR1(External interrupt configuration register 1)   :: offset : 0x08
AFIO_EXTICR2(External interrupt configuration register 2)   :: offset : 0x0C
AFIO_EXTICR3(External interrupt configuration register 3)   :: offset : 0x10
AFIO_EXTICR4(External interrupt configuration register 4)   :: offset : 0x14
AFIO_MAPR2(AF remap and debug I/O configuration register2)  :: offset : 0x1C
***************************************************************/
#define     AFIO_EVCR           0x40010000
#define     AFIO_MAPR           0x40010004
#define     AFIO_EXTICR1        0x40010008
#define     AFIO_EXTICR2        0x4001000C
#define     AFIO_EXTICR3        0x40010010
#define     AFIO_EXTICR4        0x40010014
#define     AFIO_MAPR2          0x4001001C
/***********************************************************************
timer control register
BASE ADRESS ::0x40000000~0x400003ff
TIM2_CR1 :: offset : 0x00
TIM2_CR2 :: offset : 0x04
TIM2_SMCR :: offset : 0x08
TIM2_DIER :: offset :0x0C
TIM2_SR   :: offset :0x10
TIM2_EGR  :: offset : 0x14
TIM2_CNT   :: offset : 0x24
TIM2_PSC  :: offset : 0x28
TIM2_ARR  ::0ffset : 0x2C
************************************************************************/
#define   TIM2_CR1      0x40000000
#define   TIM2_CR2      0x40000004
#define   TIM2_SMCR     0x40000008
#define   TIM2_DIER     0x4000000C
#define   TIM2_SR       0x40000010
#define   TIM2_EGR      0x40000014 
#define   TIM2_CNT      0x40000024
#define   TIM2_PSC      0x40000028
#define   TIM2_ARR      0x4000002C
/************************************************************************/
unsigned long int_num;
unsigned long k;
void TIM2_IRQHandler(void){
  /* Clear TIM2 update pending flag */ 
(*(volatile unsigned *)TIM2_SR)&=0xfffffffe;  
  int_num++;
  int_num=int_num%2;
 
  if(int_num==0)(*(volatile unsigned *)GPIOB_ODR_address)=0x00320; 
      else (*(volatile unsigned *)GPIOB_ODR_address)=0x00220; 
}
main(){

/*************************************************************************/
// Initialize CLOCK Parameter
/*************************************************************************/
 //HSE ON enable  
(*(volatile unsigned *)RCC_CR_address)|=0x00010000; 
//set flash access latency
(*(volatile unsigned *)Flash_ACR_address)|=0x00000002; 
//PPRE2=0,PPRE1=/2,HPERE=0
(*(volatile unsigned *)RCC_CFGR_address)|=0x00000400;
//PLL SOURCE =HSE, PLL XTPRE=0, PLLMUL= x6
(*(volatile unsigned *)RCC_CFGR_address)|=0x00110000; 
//PLL enable
(*(volatile unsigned *)RCC_CR_address)|=0x01010000; 
// all clock interrupt disable
(*(volatile unsigned *)RCC_CIR_address)|=0x00000000;
//PLL selected as system clock
(*(volatile unsigned *)RCC_CFGR_address)|=0x00000002; 



 /**********************************************************************/ 
//enable port B for LED out
/**********************************************************************/ 
(*(volatile unsigned *)RCC_APB2ENR_address)|=0x08;    //PortB &PortA enable
/************************************************************************/
//TIM2 CLOCK Enable
/************************************************************************/
(*(volatile unsigned *)RCC_APB1ENR_address)|=0x01;

/****************************************************************************/
//VTOR(vector table offset) Configuration 
/****************************************************************************/
(*(volatile unsigned *)SCB_VTOR_address)|=0x00000000;   // vector table base address=0x08000000
(*(volatile unsigned *)SCB_AIRCR_address)|=0x0700;  // no group priority, only sub priority

/******************************************************************************/
//IPR(Interrupt Priority Register) Configuration
/******************************************************************************/
(*(volatile unsigned *)NVIC_IPR_address)|=0x00000000;

/****************************************************************************/
(*(volatile unsigned *)NVIC_ISER_address)|=0x10000000;  //enable TIM2 Interrupt

/******************************************************************************/
 // Clear TIM2 update pending flag 
(*(volatile unsigned *)TIM2_SR)=0x00; 
//up counter, counter disable
(*(volatile unsigned *)TIM2_CR1)=0x0000; 
//update interrupt enable
(*(volatile unsigned *)TIM2_DIER)=0x0001; 
//frescaler counter clear,register update
(*(volatile unsigned *)TIM2_EGR)=0x0001;
 //set prescaler
(*(volatile unsigned *)TIM2_PSC)=0xEA5F; 
 //set auto reload register
(*(volatile unsigned *)TIM2_ARR)=0x4af;  
//counter enable
(*(volatile unsigned *)TIM2_CR1)|=0x0001;  
//(*(volatile unsigned *)TIM2_CNT)|=0x4af;

/**************************************************************************/
//** PORTB initialization
//CNF : general purpose open drain output
//Mode : output mode(open drain, max speed : 50MHz)
(*(volatile unsigned *)GPIOB_CRL_address)|=0x00700000; //set bit5 mode&cnf

/**************************************************************************/
//** PORTB initialization
//CNF : general purpose open drain output
//Mode : output mode(open drain, max speed : 50MHz)
/**************************************************************************/
(*(volatile unsigned *)GPIOB_CRH_address)|=0x00000077; //set bit8,9 mode&cnf

/*******************************************************************************/
//Initialization outport
/*******************************************************************************/
(*(volatile unsigned *)GPIOB_ODR_address)=0x0320;
int_num=0;
while(1){

}
}



